<?php
/* Latest file update: 2023-07-20 */

/*
.htaccess

#forums
RewriteRule ^([0-9A-Za-z-\+_]+)-([0-9]+)/index([0-9]+)\.html$ ./index.php?action=vtopic&forum=$2&page=$3&mdrw=on
RewriteRule ^([0-9A-Za-z-\+_]+)-([0-9]+)/$ ./index.php?action=vtopic&forum=$2&page=1&mdrw=on

#topics
RewriteRule ([0-9A-Za-z-\+._]+)-([0-9]+)/([0-9A-Za-z-\+._]+)-([0-9]+)-([0-9]+)\.html$ ./index.php?action=vthread&forum=$2&topic=$4&page=$5&mdrw=on
RewriteRule ([0-9A-Za-z-\+._]+)-([0-9]+)/([0-9A-Za-z-\+._]+)-([0-9]+)\.html$ ./index.php?action=vthread&forum=$2&topic=$4&page=1&mdrw=on

*/

if (!defined('INCLUDED776')) die ('Fatal error.');

if(defined('REPLACE_PATH')) $replacePath=REPLACE_PATH; else $replacePath='';

/* Custom mod_rewrite */
function convertTitle($topicTitle){

$replace = array(
'&lt;' => '', '&gt;' => '', '&#039;' => '', '&amp;' => '', '&quot;' => '', 'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A', 'Ä' => 'Ae', '&Auml;' => 'A', 'Å' => 'A', 'Ā' => 'A', 'Ą' => 'A', 'Ă' => 'A', 'Æ' => 'Ae', 'Ç' => 'C', 'Ć' => 'C', 'Č' => 'C', 'Ĉ' => 'C', 'Ċ' => 'C', 'Ď' => 'D', 'Đ' => 'D', 'Ð' => 'D', 'È' => 'E', 'É' => 'E', 'Ê' => 'E', 'Ë' => 'E', 'Ē' => 'E', 'Ę' => 'E', 'Ě' => 'E', 'Ĕ' => 'E', 'Ė' => 'E', 'Ĝ' => 'G', 'Ğ' => 'G', 'Ġ' => 'G', 'Ģ' => 'G', 'Ĥ' => 'H', 'Ħ' => 'H', 'Ì' => 'I', 'Í' => 'I', 'Î' => 'I', 'Ï' => 'I', 'Ī' => 'I', 'Ĩ' => 'I', 'Ĭ' => 'I', 'Į' => 'I', 'İ' => 'I', 'Ĳ' => 'IJ', 'Ĵ' => 'J', 'Ķ' => 'K', 'Ł' => 'K', 'Ľ' => 'K', 'Ĺ' => 'K', 'Ļ' => 'K', 'Ŀ' => 'K', 'Ñ' => 'N', 'Ń' => 'N', 'Ň' => 'N', 'Ņ' => 'N', 'Ŋ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O', 'Õ' => 'O', 'Ö' => 'Oe', '&Ouml;' => 'Oe', 'Ø' => 'O', 'Ō' => 'O', 'Ő' => 'O', 'Ŏ' => 'O', 'Œ' => 'OE', 'Ŕ' => 'R', 'Ř' => 'R', 'Ŗ' => 'R', 'Ś' => 'S', 'Š' => 'S', 'Ş' => 'S', 'Ŝ' => 'S', 'Ș' => 'S', 'Ť' => 'T', 'Ţ' => 'T', 'Ŧ' => 'T', 'Ț' => 'T', 'Ù' => 'U', 'Ú' => 'U', 'Û' => 'U', 'Ü' => 'Ue', 'Ū' => 'U', '&Uuml;' => 'Ue', 'Ů' => 'U', 'Ű' => 'U', 'Ŭ' => 'U', 'Ũ' => 'U', 'Ų' => 'U', 'Ŵ' => 'W', 'Ý' => 'Y', 'Ŷ' => 'Y', 'Ÿ' => 'Y', 'Ź' => 'Z', 'Ž' => 'Z', 'Ż' => 'Z', 'Þ' => 'T', 'à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'ae', '&auml;' => 'ae', 'å' => 'a', 'ā' => 'a', 'ą' => 'a', 'ă' => 'a', 'æ' => 'ae', 'ç' => 'c', 'ć' => 'c', 'č' => 'c', 'ĉ' => 'c', 'ċ' => 'c', 'ď' => 'd', 'đ' => 'd', 'ð' => 'd', 'è' => 'e', 'é' => 'e', 'ê' => 'e', 'ë' => 'e', 'ē' => 'e', 'ę' => 'e', 'ě' => 'e', 'ĕ' => 'e', 'ė' => 'e', 'ƒ' => 'f', 'ĝ' => 'g', 'ğ' => 'g', 'ġ' => 'g', 'ģ' => 'g', 'ĥ' => 'h', 'ħ' => 'h', 'ì' => 'i', 'í' => 'i', 'î' => 'i', 'ï' => 'i', 'ī' => 'i', 'ĩ' => 'i', 'ĭ' => 'i', 'į' => 'i', 'ı' => 'i', 'ĳ' => 'ij', 'ĵ' => 'j', 'ķ' => 'k', 'ĸ' => 'k', 'ł' => 'l', 'ľ' => 'l', 'ĺ' => 'l', 'ļ' => 'l', 'ŀ' => 'l', 'ñ' => 'n', 'ń' => 'n', 'ň' => 'n', 'ņ' => 'n', 'ŉ' => 'n', 'ŋ' => 'n', 'ò' => 'o', 'ó' => 'o', 'ô' => 'o', 'õ' => 'o', 'ö' => 'oe', '&ouml;' => 'oe', 'ø' => 'o', 'ō' => 'o', 'ő' => 'o', 'ŏ' => 'o', 'œ' => 'oe', 'ŕ' => 'r', 'ř' => 'r', 'ŗ' => 'r', 'š' => 's', 'ù' => 'u', 'ú' => 'u', 'û' => 'u', 'ü' => 'ue', 'ū' => 'u', '&uuml;' => 'ue', 'ů' => 'u', 'ű' => 'u', 'ŭ' => 'u', 'ũ' => 'u', 'ų' => 'u', 'ŵ' => 'w', 'ý' => 'y', 'ÿ' => 'y', 'ŷ' => 'y', 'ž' => 'z', 'ż' => 'z', 'ź' => 'z', 'þ' => 't', 'ß' => 'ss', 'ſ' => 'ss', 'ый' => 'iy', 'А' => 'A', 'Б' => 'B', 'В' => 'V', 'Г' => 'G', 'Д' => 'D', 'Е' => 'E', 'Ё' => 'YO', 'Ж' => 'ZH', 'З' => 'Z', 'И' => 'I', 'Й' => 'Y', 'К' => 'K', 'Л' => 'L', 'М' => 'M', 'Н' => 'N', 'О' => 'O', 'П' => 'P', 'Р' => 'R', 'С' => 'S', 'Т' => 'T', 'У' => 'U', 'Ф' => 'F', 'Х' => 'H', 'Ц' => 'C', 'Ч' => 'CH', 'Ш' => 'SH', 'Щ' => 'SCH', 'Ъ' => '', 'Ы' => 'Y', 'Ь' => '', 'Э' => 'E', 'Ю' => 'YU', 'Я' => 'YA', 'а' => 'a', 'б' => 'b', 'в' => 'v', 'г' => 'g', 'д' => 'd', 'е' => 'e', 'ё' => 'yo', 'ж' => 'zh', 'з' => 'z', 'и' => 'i', 'й' => 'y', 'к' => 'k', 'л' => 'l', 'м' => 'm', 'н' => 'n', 'о' => 'o', 'п' => 'p', 'р' => 'r', 'с' => 's', 'т' => 't', 'у' => 'u', 'ф' => 'f', 'х' => 'h', 'ц' => 'c', 'ч' => 'ch', 'ш' => 'sh', 'щ' => 'sch', 'ъ' => '', 'ы' => 'y', 'ь' => '', 'э' => 'e', 'ю' => 'yu', 'я' => 'ya'
);

$topicTitle=str_replace(array_keys($replace), $replace, $topicTitle);

$topicTitle=preg_replace("/\.{2,}/", '', $topicTitle);

$topicTitle=str_replace(array('&amp;', '+', '/', '-'), ' ', strtolower_unicode($topicTitle));
$topicTitle=preg_replace("/&#*[0-9a-z]+;/i", '', $topicTitle);

$topicTitle=preg_replace("#([^ ])([(])([^ ])#", "\\1 \\2\\3", $topicTitle);
$topicTitle=preg_replace("#([^ ])([)])([^ ])#", "\\1\\2 \\3", $topicTitle);
$topicTitle=preg_replace("#([^ ])([,!?=])([^ ])#", "\\1\\2 \\3", $topicTitle);

$topicTitle=preg_replace('#[^a-z0-9._ ]#', '', $topicTitle);
$topicTitle=preg_replace("#[ ]{2,}#", ' ', $topicTitle);

$topicTitle=str_replace(' ', '-', trim($topicTitle));

/* Cut non-sensitive words */

$cutWords=array('and', 'or', 'i', 'a', 'an', 'the', 's', 'm', 't', 'd');
foreach($cutWords as $w) {
$topicTitle=preg_replace("#^(".$w.")[-](.*?)$#i", '\\2', $topicTitle);
$topicTitle=preg_replace("#^(.+?)[-](".$w.")$#i", '\\1', $topicTitle);
}

$w2=array();
foreach($cutWords as $w) $w2[]='-'.$w.'-';
$topicTitle=str_replace($w2, '-', $topicTitle);

if(strlen_unicode($topicTitle)>70){
$newtopic=explode('-', $topicTitle);

while(strlen_unicode($topicTitle)>70){
array_pop($newtopic);
$topicTitle=implode('-', $newtopic);
}

}

//remove ending digits so they don't conflict with the page numbers and IDs
$topicTitle=preg_replace("#^(.*?)-([0-9-]+)$#", '\\1', $topicTitle);

if(strlen_unicode($topicTitle)<3) $topicTitle='topic';

return $topicTitle;

}

if($_SERVER['SERVER_NAME']=='www.minibb.com' or $_SERVER['SERVER_NAME']=='localhost'){
$specifiedForums=array(
9=>'news',
1=>'other',
11=>'plugins',
12=>'custom',
5=>'coding',
19=>'recycled'
);
}

function genForumURL($main_url, $forum_id, $forum_name){

if(isset($GLOBALS['specifiedForums'][$forum_id])) $forum_short=$GLOBALS['specifiedForums'][$forum_id];
else{
if($forum_name=='#GET#') $forum_name=getForumTitleById($forum_id);
$forum_name=$forum_short=convertTitle($forum_name);
}

$full_url=$main_url.'/'.$forum_short.'-'.$forum_id;
return $full_url;
}

function addForumURLPage($full_url, $currPageNum){
if($currPageNum!=PAGE1_OFFSET+1) $full_url.='/index'.$currPageNum.'.html';
else $full_url.='/';
return $full_url;
}

function genTopicURL($main_url, $forum_id, $forum_name, $topic_id, $topicTitle){

if(isset($GLOBALS['specifiedForums'][$forum_id])) $forumName=$GLOBALS['specifiedForums'][$forum_id];
else{
if($forum_name=='#GET#') $forum_name=getForumTitleById($forum_id);
$forumName=convertTitle($forum_name);
}

if($topicTitle=='#GET#') $topicTitle=getTopicTitleById($topic_id);
$topicTitle=convertTitle($topicTitle);

$full_url=$main_url.'/'.$forumName.'-'.$forum_id.'/'.$topicTitle.'-'.$topic_id;
return $full_url;
}

function addTopicURLPage($full_url, $currPageNum){
if($currPageNum!=PAGE1_OFFSET+1) $full_url.='-'.$currPageNum.'.html';
else $full_url.='.html';
return $full_url;
}

function parseRequestForumURL($main_url){
$url=explode('/', $_SERVER['REQUEST_URI']);
$urll=sizeof($url);
$url1=$url[$urll-2];
$url2=$url[$urll-1];
return $main_url.'/'.$url1.'/'.$url2;
}

function parseRequestTopicURL($main_url){
$url=explode('/', $_SERVER['REQUEST_URI']);
$urll=sizeof($url);
$url1=$url[$urll-2];
$url2=$url[$urll-1];
return $main_url.'/'.$url1.'/'.$url2;
}

?>